import oscP5.*;
import netP5.*;
OscP5 oscP5;
NetAddress reaktorAddress;
NetAddress tabletAddress;
ArrayList<Link> theLinks;
ArrayList<Ball> theBalls;
float maxRadius=30;
int minDistToLink=100;

float initPosX, initPosY;
PVector position; 
void setup() {
  size(800, 600);
  oscP5 = new OscP5(this, 8000);
  reaktorAddress = new NetAddress("127.0.0.1", 8001);//to reaktor
  tabletAddress= new NetAddress("192.168.0.11", 12000);//to tablet
  theBalls=new ArrayList<Ball>();
  theLinks=new ArrayList<Link>();
  position= new PVector(initPosX, initPosY);
}

void draw() {
  background(0);
  for (int i = 0; i < theBalls.size(); i++) {
    Ball ball = theBalls.get(i);
    ball.update();
    ball.display();
    position= ball.getPosition();
    sendPosition("/"+i+"/position", position.x/displayWidth, position.y/displayHeight);
    float radius=ball.getRadius(); 
    ball.setRadius(radius*0.995);
    radius=map(ball.getRadius(), 0, maxRadius, 0, 1);
    sendRadius("/"+i+"/radius", radius);
    if (ball.checkIfDead()==true||ball.getPosition().x>displayWidth||ball.getPosition().x<0||ball.getPosition().y>displayHeight||ball.getPosition().y<0)
    {
      ball.destructor();
      theBalls.remove(i);
    }
    //liens si proximitée
    for (int j = 0; j < theBalls.size(); j++) {
      Ball ballTested = theBalls.get(j);
      float distance = PVector.dist(ballTested.getPosition(), ball.getPosition());
      if (distance<minDistToLink && distance>0)
      {//Todo, tester si le liens n'existe pas deja avant de le recréer. 
        println("link :"+i+" "+j); 
        if(theLinks.contains(new Link(ball,ballTested)))
        println("exist" );
        theLinks.add(new Link(ball, ballTested));
      }
    }
    ball.setCircleWidthFactor(10*mouseX/displayWidth);
    ball.setCircleWidth(5*mouseY/displayHeight);
  }
  for (int i = theLinks.size()-1; i >= 0; i--) {
    Link link=theLinks.get(i);
    if (link.checkIfDead()==false)
    {
      link.display();
    }
    else
    {
      theLinks.remove(i);
    }
  }
}
void sendRadius(String address, float radius)
{
  OscMessage myMessage = new OscMessage(address);
  myMessage.add(radius);
  oscP5.send(myMessage, reaktorAddress);
}
void sendPosition(String address, float posX, float posY)
{
  OscMessage myMessage = new OscMessage(address);
  myMessage.add(posX);
  myMessage.add(posY);
  oscP5.send(myMessage, reaktorAddress); 
  //oscP5.send(myMessage, tabletAddress);
}
void oscEvent(OscMessage theOscMessage) {
  print("### received an osc message.");
  print(" addrpattern: "+theOscMessage.addrPattern());
  println(" typetag: "+theOscMessage.typetag());
  initPosY=theOscMessage.get(0).floatValue();
  initPosY=1-initPosY;
  initPosX=theOscMessage.get(1).floatValue();
  print ("posX="+initPosX);
  println ("posY="+initPosY);
  theBalls.add(new Ball(initPosX* displayHeight, initPosY* displayWidth, random(3, maxRadius), maxRadius, (int)random(1, 6)));
}

void mousePressed() {
  theBalls.add(new Ball(mouseX, mouseY, random(3, maxRadius), maxRadius, (int)random(1, 6)));
}
void keyPressed() {
  if (key == 'l' || key == 'L') {
    if (theBalls.size()>=2)
    {
      Ball ball1=theBalls.get(theBalls.size()-1);
      Ball ball2=theBalls.get(theBalls.size()-2);   
      theLinks.add(new Link(ball1, ball2));
    }
  }
}

